###############################################################################
###############################################################################
# PoaS - Perlonall Site                                                       #
#-----------------------------------------------------------------------------#
# admin.pl - this code handles the admin section based on YaWPS               #
#                                                                             #
# Copyright (C) 2001 by Luckie (luckie_aria@excite.com)                       #
#                                                                             #
# This program is free software; you can redistribute it and/or               #
# modify it under the terms of the GNU General Public License                 #
# as published by the Free Software Foundation; either version 2              #
# of the License, or (at your option) any later version.                      #
#                                                                             #
# This program is distributed in the hope that it will be useful,             #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with this program; if not, write to the Free Software                 #
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. #
#                                                                             #
#                                                                             #
# File: admin.pl, Last modified: 22:54 12/31/2001                             #
###############################################################################
###############################################################################


###############
sub siteadmin {
###############
	if ($username ne "admin") { error("$err{'011'}"); }

	print_top();
	$navbar = ">>> $nav{'042'}";
	print qq~
<b>$nav{'042'}</b><br>
<a href="$pageurl/$admin&amp;op=siteconfig">Site Configuration</a><br>
<a href="$pageurl/$admin&amp;op=welcomemsg">Welcome Message</a><br>
<a href="$baseurl/cgi-bin/admin/themes/view.cgi">Themes Administration</a><br>
<a href="$baseurl/cgi-bin/admin/banners/view.cgi">Banner Administration</a><br>
<a href="$baseurl/cgi-bin/admin/downloads/view.cgi">Download Administration</a><br>
<a href="$baseurl/cgi-bin/admin/links/view.cgi">Link Administration</a><br>
<a href="$pageurl/$cgi\?action=fileman">Files Manager</a><br>
<br>
<b>$nav{'043'}</b><br>
<a href="$pageurl/$admin&amp;op=managecats">Categories (reorder/create/remove)</a><br>
<a href="$pageurl/$admin&amp;op=manageboards">Boards (reorder/create/remove)</a><br>
<a href="$pageurl/$admin&amp;op=setcensor">Set censored words</a><br>
<br>
<b>$nav{'044'}</b><br>
<a href="$pageurl/$admin&amp;op=polladmin">Poll Admin (edit/create/remove)</a><br>
<br>
<b>$nav{'024'}</b><br>
<a href="$pageurl/$admin&amp;op=verifynews">New Articles (publish/remove)</a><br>
<a href="$pageurl/$admin&amp;op=modifynews">News/Comments (edit/move/remove)</a><br>
<a href="$pageurl/$admin&amp;op=topicadmin">Topic Categories (rename/create/remove)</a><br>
<br>
<b>Block Administration</b><br>
<a href="$baseurl/cgi-bin/admin/blocks/left/view.cgi">Left Block</a><br>
<a href="$baseurl/cgi-bin/admin/blocks/right/view.cgi">Right Block</a><br>

~;
	print_bottom();
	exit;
}

################
sub siteconfig {
################
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, "$scriptdir/config.pl") || error("$err{'001'} $scriptdir/config.pl");
	lock(FILE);
	chomp(@config = <FILE>);
	unlock(FILE);
	close(FILE);

	print_top();
	$navbar = ">>> $nav{'042'} >>> Site Configuration";
	print qq~<form action="$admin&amp;op=siteconfig2" method="post">
<table border="0" width="100%" cellpading="0" cellspacing="0">
<tr>
<td colspan="2"><b>General settings:</b></td>
</tr>
<tr>
<td>Pagename</td>
<td><input type="text" name="pagename" value="$pagename" size="30"></td>
</tr>
<tr>
<td>Pageurl</td>
<td><input type="text" name="pageurl" value="$pageurl" size="30"></td>
</tr>
<tr>
<td>Pagetitle</td>
<td><input type="text" name="pagetitle" value="$pagetitle" size="30"></td>
</tr>
<tr>
<td>Script Filename</td>
<td><input type="text" name="cgi" value="$cgi" size="30"></td>
</tr>
<tr>
<td>Cookieusername</td>
<td><input type="text" name="cookieusername" value="$cookieusername" size="30"></td>
</tr>
<tr>
<td>Cookiepassword</td>
<td><input type="text" name="cookiepassword" value="$cookiepassword" size="30"></td>
</tr>
<tr>
<td>Cookietheme</td>
<td><input type="text" name="cookieusertheme" value="$cookieusertheme" size="30"></td>
</tr>
<tr>
<td>Mailertype</td>
<td><input type="text" name="mailtype" maxlength="1" value="$mailtype" size="1"> <small>(0..sendmail; 1..SMTP)</small></td>
</tr>
<tr>
<td>Path to mailprogram</td>
<td><input type="text" name="mailprogram" value="$mailprogram" size="30"></td>
</tr>
<tr>
<td>SMTP-Server</td>
<td><input type="text" name="smtp_server" value="$smtp_server" size="30"></td>
</tr>
<tr>
<td>Path to website rootdirectory</td>
<td><input type="text" name="basedir" value="$basedir" size="30"></td>
</tr>
<tr>
<td>Main URL to website</td>
<td><input type="text" name="baseurl" value="$baseurl" size="30"></td>
</tr>
<tr>
<td>Main script URL to website</td>
<td><input type="text" name="scripturl" value="$scripturl" size="30"></td>
</tr>
<tr>
<td>Path to script maindirectory</td>
<td><input type="text" name="scriptdir" value="$scriptdir" size="30"></td>
</tr>
<tr>
<td>Path to script sources</td>
<td><input type="text" name="sourcedir" value="$sourcedir" size="30"></td>
</tr>
<tr>
<td>Path to data directory</td>
<td><input type="text" name="datadir" value="$datadir" size="30"></td>
</tr>
<tr>
<td>Path to members directory</td>
<td><input type="text" name="memberdir" value="$memberdir" size="30"></td>
</tr>
<tr>
<td>Path to images directory</td>
<td><input type="text" name="imagesdir" value="$imagesdir" size="30"></td>
</tr>
<tr>
<td>Path to themes directory</td>
<td><input type="text" name="themesdir" value="$themesdir" size="30"></td>
</tr>
<tr>
<td>Path/URL to images directory</td>
<td><input type="text" name="imagesurl" value="$imagesurl" size="30"></td>
</tr>
<tr>
<td>Path/URL to themes directory</td>
<td><input type="text" name="themesurl" value="$themesurl" size="30"></td>
</tr>
<tr>
<td>Site Language</td>
<td><input type="text" name="lang" value="$lang" size="30"></td>
</tr>
<tr>
<td>Banner Display</td>
<td><input type="text" name="showban" value="$showban" size="30"><small>(0..deactivated; 1..activated)</small></td>
</tr>
<tr>
<td colspan="2"><b>News specific settings:</b></td>
</tr>
<tr>
<td>Path to topics directory</td>
<td><input type="text" name="topicsdir" value="$topicsdir" size="30"></td>
</tr>
<tr>
<td>Max # of news on frontpage</td>
<td><input type="text" maxlength="2" name="maxnews" value="$maxnews" size="1"></td>
</tr>
<tr>
<td>Max # of topics on topicscatpage</td>
<td><input type="text" maxlength="2" name="maxtopics" value="$maxtopics" size="1"></td>
</tr>
<tr>
<td>Allow users to post articles</td>
<td><input type="text" maxlength="1" name="enable_userarticles" value="$enable_userarticles" size="1"> <small>(0..no; 1..yes)</small></td>
</tr>
<td>Allow HTML</td>
<td><input type="text" maxlength="1" name="allow_html" value="$allow_html" size="1"> <small>(0..no; 1..yes)</small></td>
</tr>
<tr>
<td colspan="2"><b>Forum specific settings:</b></td>
</tr>
<tr>
<td>Path to forums directory</td>
<td><input type="text" name="boardsdir" value="$boardsdir" size="30"></td>
</tr>
<tr>
<td>Path to messages directory</td>
<td><input type="text" name="messagedir" value="$messagedir" size="30"></td>
</tr>
<tr>
<td>Enable guestposting</td>
<td><input type="text" maxlength="1" name="enable_guestposting" value="$enable_guestposting" size="1"> <small>(0..no; 1..yes)</small></td>
</tr>
<tr>
<td>Enable notification</td>
<td><input type="text" maxlength="1" name="enable_notification" value="$enable_notification" size="1"> <small>(0..no; 1..yes)</small></td>
</tr>
<tr>
<td>Max # of forumtopics</td>
<td><input type="text" maxlength="2" name="maxdisplay" value="$maxdisplay" size="1"></td>
</tr>
<tr>
<td>Max # of forummessages</td>
<td><input type="text" maxlength="2" name="maxmessagedisplay" value="$maxmessagedisplay" size="1"></td>
</tr>
<tr>
<td>Max # of forummessages</td>
<td><input type="text" maxlength="2" name="maxmessagedisplay" value="$maxmessagedisplay" size="1"></td>
</tr>
<tr>
<td>Insert original</td>
<td><input type="text" maxlength="1" name="insert_original" value="$insert_original" size="1"> <small>(0..no; 1..yes)</small></td>
</tr>
<tr>
<td>Enable UBBC</td>
<td><input type="text" maxlength="1" name="enable_ubbc" value="$enable_ubbc" size="1"> <small>(0..no; 1..yes)</small></td>
</tr>
<tr>
<td>Max age of logiles</td>
<td><input type="text" maxlength="3" name="max_log_days_old" value="$max_log_days_old" size="1"></td>
</tr>
<tr>
<td colspan="2"><b>Stats specific settings:</b></td>
</tr>
<tr>
<td>Path to stats directory</td>
<td><input type="text" name="logdir" value="$logdir" size="30"></td>
</tr>
<tr>
<td>Time between logging of IPs (minutes)</td>
<td><input type="text" maxlength="3" name="ip_time" value="$ip_time" size="1"></td>
</tr>
<tr>
<td>Show top browsers</td>
<td><input type="text" maxlength="1" name="top_browsers" value="$top_browsers" size="1"> <small>(0..no; 1..yes)</small></td>
</tr>
<tr>
<td>Show top OS</td>
<td><input type="text" maxlength="1" name="top_os" value="$top_os" size="1"> <small>(0..no; 1..yes)</small></td>
</tr>
<tr>
<td colspan="2"><b>Links specific settings:</b></td>
</tr>
<tr>
<td>Path to links directory</td>
<td><input type="text" name="linksdir" value="$linksdir" size="30"></td>
</tr>
<tr>
<td>Max # of links</td>
<td><input type="text" maxlength="2" name="maxlinks" value="$maxlinks" size="1"></td>
</tr>
<tr>
<td colspan="2"><b>Download specific settings:</b></td>
</tr>
<tr>
<td>Path to downloads directory</td>
<td><input type="text" name="downloadsdir" value="$downloadsdir" size="30"></td>
</tr>
<tr>
<td>Max # of downloads</td>
<td><input type="text" maxlength="2" name="maxdownloads" value="$maxdownloads" size="1"></td>
</tr>
<tr>
<td colspan="2"><b>Other settings:</b></td>
</tr>
<tr>
<td>Time difference</td>
<td><input type="text" maxlength="2" name="timeoffset" value="$timeoffset" size="1"></td>
</tr>
<tr>
<td>Max. height of memberpics (in pixel)</td>
<td><input type="text" maxlength="3" name="memberpic_height" value="$memberpic_height" size="1"></td>
</tr>
<tr>
<td>Max. width of memberpics (in pixel)</td>
<td><input type="text" maxlength="3" name="memberpic_width" value="$memberpic_width" size="1"></td>
</tr>
<tr>
<td>File locking</td>
<td><input type="text" maxlength="1" name="use_flock" value="$use_flock" size="1"> <small>(0..no; 1..yes)</small></td>
</tr>
<tr>
<td>LOCK_EX</td>
<td><input type="text" maxlength="2" name="LOCK_EX" value="$LOCK_EX" size="1"></td>
</tr>
<tr>
<td>LOCK_UN</td>
<td><input type="text" maxlength="2" name="LOCK_UN" value="$LOCK_UN" size="1"></td>
</tr>
<tr>
<td>IIS</td>
<td><input type="text" maxlength="1" name="IIS" value="$IIS" size="1"> <small>(0..auto; 1..IIS; 2..Apache)</small></td>
</tr>
<tr>
<td align="center" colspan="2"><input type="submit" value="Save"></td>
</tr>
</table>
</form>
~;
	print_bottom();
	exit;
}

#################
sub siteconfig2 {
#################
	open(FILE, ">$scriptdir/config.pl") || error("$err{'016'} $scriptdir/config.pl");
	lock(FILE);
	print FILE qq~###############################################################################
###############################################################################
# PoaS - Perlonall Site                                                       #
#-----------------------------------------------------------------------------#
# config.pl - the main config file based on YaWPS                             #
#                                                                             #
# Copyright (C) 2001 by Luckie (luckie_aria\@excite.com)                      #
#                                                                             #
# This program is free software; you can redistribute it and/or               #
# modify it under the terms of the GNU General Public License                 #
# as published by the Free Software Foundation; either version 2              #
# of the License, or (at your option) any later version.                      #
#                                                                             #
# This program is distributed in the hope that it will be useful,             #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with this program; if not, write to the Free Software                 #
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. #
#                                                                             #
#                                                                             #
# File: config.pl, Last modified: $date                                       #
###############################################################################
###############################################################################


##################
# General Settings
##################
\$pagename = "$input{'pagename'}";
\$pageurl = "$input{'pageurl'}";
\$pagetitle = "$input{'pagetitle'}";

\$cgi = "$input{'cgi'}";
\$cookieusername = "$input{'cookieusername'}";
\$cookiepassword = "$input{'cookiepassword'}";
\$cookieusertheme = "$input{'cookieusertheme'}";

\$mailtype = "$input{'mailtype'}";
\$mailprogram = "$input{'mailprogram'}";
\$smtp_server =  "$input{'smtp_server'}";

\$basedir   = "$input{'basedir'}";
\$baseurl   = "$input{'baseurl'}";
\$scriptdir = "$input{'scriptdir'}";
\$scripturl = "$input{'scripturl'}";
\$sourcedir = "$input{'sourcedir'}";
\$datadir   = "$input{'datadir'}";
\$memberdir = "$input{'memberdir'}";
\$imagesdir = "$input{'imagesdir'}";
\$themesdir = "$input{'themesdir'}";

\$imagesurl = "$input{'imagesurl'}";
\$themesurl = "$input{'themesurl'}";

\$lang = "$input{'lang'}";

\$showban = "$input{'showban'}";

########################
# News Specific Settings
########################
\$topicsdir = "$input{'topicsdir'}";
\$maxnews = $input{'maxnews'};
\$maxtopics = $input{'maxtopics'};
\$enable_userarticles = $input{'enable_userarticles'};
\$allow_html = $input{'allow_html'};

##########################
# Forums Specific Settings
##########################
\$boardsdir = "$input{'boardsdir'}";
\$messagedir = "$input{'messagedir'}";

\$enable_guestposting = $input{'enable_guestposting'};
\$enable_notification = $input{'enable_notification'};
\$maxdisplay = $input{'maxdisplay'};
\$maxmessagedisplay = $input{'maxmessagedisplay'};
\$insert_original = $input{'insert_original'};
\$enable_ubbc = $input{'enable_ubbc'};
\$max_log_days_old = $input{'max_log_days_old'};

#########################
# Stats Specific Settings
#########################
\$logdir = "$input{'logdir'}";

\$ip_time = 5;

\$top_browsers = $input{'top_browsers'};
\$top_os = $input{'top_os'};

#########################
# Links Specific Settings
#########################
\$linksdir = "$input{'linksdir'}";
\$maxlinks = "$input{'maxlinks'}";

#########################
# Downloads Specific Settings
#########################
\$downloadsdir = "$input{'downloadsdir'}";
\$maxdownloads = "$input{'maxdownloads'}";

################
# Other Settings
################
\$timeoffset = $input{'timeoffset'};

\$memberpic_height = $input{'memberpic_height'}; 
\$memberpic_width = $input{'memberpic_width'};

\$use_flock = $input{'use_flock'};
\$LOCK_EX = $input{'LOCK_EX'};
\$LOCK_UN = $input{'LOCK_UN'};

\$IIS =  $input{'IIS'};

1; #return true
~;
	unlock(FILE);
	close(FILE);

	print "Location: $pageurl/$admin\&op=siteconfig\n\n";
	exit;
}

################
sub welcomemsg {
################
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, "$datadir/welcomemsg.txt") || error("$err{'001'} $datadir/welcomemsg.txt");
	lock(FILE);
	chomp(@lines = <FILE>);
	unlock(FILE);
	close(FILE);

	$subject = htmltotext($lines[0]);
	$message = htmltotext($lines[1]);

	$navbar = ">>> $nav{'042'} >>> Edit Welcome Message";
	print_top();
	print qq~<form action="$pageurl/$admin&amp;op=welcomemsg2" method="post">
<table border="0" width="100%" cellpading="0" cellspacing="0">
<tr>
<td>
Main Title:<br>
<input type="text" name="subject" value="$subject" size="40">
</td>
</tr>
<tr>
<td>
Main Text  (HTML allowed):<br>
<textarea name="message" cols="40" rows="10">$message</textarea>
</td>
</tr>
<tr>
<td><input type="submit" value="Save"><input type="reset" value="Reset"></td>
</tr>
</table>
</form>
~;
	print_bottom();
	exit;
}

#################
sub welcomemsg2 {
#################
	if ($username ne "admin") { error("$err{'011'}"); }
	error("$err{'014'}") unless ($input{'subject'});
	error("$err{'015'}") unless ($input{'message'});

	chomp($input{'subject'});
	chomp($input{'message'});

	$subject = htmlescape($input{'subject'});
	$message = htmlescape($input{'message'});

	open(FILE, ">$datadir/welcomemsg.txt") || error("$err{'016'} $datadir/welcomemsg.txt");
	lock(FILE);
	print FILE "$subject\n";
	print FILE "$message\n";
	unlock(FILE);
	close(FILE);

	print "Location: $pageurl/$admin\&op=welcomemsg\n\n";
}

################
sub managecats {
################
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, "$boardsdir/cats.txt") || error("$err{'001'} $boardsdir/cats.txt");
	lock(FILE);
	chomp(@categories = <FILE>);
	unlock(FILE);
	close(FILE);

	$catsdropdown = "";
	$catlist = "";
	foreach $curcat (@categories) {
		$catsdropdown = "$catsdropdown<option>$curcat</option>";
		$catlist = "$catlist\n$curcat";
	}

	$navbar = ">>> $nav{'043'} >>> Manage Cats";

	print_top();
	print qq~<table border="0" width="100%" cellpading="0" cellspacing="0">
<tr>
<td valign="top">
<form action="$admin&amp;op=reordercats" method="post">
<b>Current categories:</b><br>
<textarea name="cats" cols="40" rows="4">$catlist</textarea><br>
<input type="submit" value="Change order">
</form>
<form action="$pageurl/$admin&amp;op=removecat" method="post">
<b>Remove category:</b><br>
<select name="cat">
$catsdropdown
</select>
<input type=submit value="Delete">
</form>
<form action="$pageurl/$admin&amp;op=createcat" method="post">
<b>Create new category:</b><br>
ID:<br>
<input type="text" size="15" name="catid"><br>
Full name:<br>
<input type="text" size="40" name="catname"><br>
Only access for membergroup:<br>
<input type="text" size="40" name="memgroup"><br>
(leave empty if none)<br>
<input type="submit" value="Create">
</form>
</td>
</tr>
</table>
~;
	print_bottom();
	exit;
}

#################
sub reordercats {
#################
	if ($username ne "admin") { error("$err{'011'}"); }

	$input{'cats'} =~ s/\r//g;
	open(FILE, "$boardsdir/cats.txt") || error("$err{'016'} $boardsdir/cats.txt");
	lock(FILE);
	print FILE "$input{'cats'}";
	unlock(FILE);
	close(FILE);
	print "Location: $pageurl/$admin\&op=managecats\n\n";
	exit;
}

###############
sub removecat {
###############
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, "$boardsdir/cats.txt") || error("$err{'001'} $boardsdir/cats.txt");
	lock(FILE);
	chomp(@categories = <FILE>);
	unlock(FILE);
	close(FILE);

	$newcatlist = "";
	foreach $curcat (@categories) {
		if ($curcat ne "$input{'cat'}") { $newcatlist = "$newcatlist$curcat\n"; }
	}

	open(FILE, ">$boardsdir/cats.txt") || error("$err{'016'} $boardsdir/cats.txt");
	lock(FILE);
	print FILE "$newcatlist";
	unlock(FILE);
	close(FILE);

	$curcat = "$input{'cat'}";
	
	open(FILE, "$boardsdir/$curcat.cat") || error("$err{'001'} $boardsdir/$curcat.cat");
	lock(CAT);
	chomp(@catinfo = <CAT>);
	unlock(CAT);
	close(CAT);

	$curcatname = "$catinfo[0]";

	$navbar = ">>> $nav{'043'} >>> Delete Cat";
	print_top();

	foreach $curboard (@catinfo) {
		if ($curboard ne "$catinfo[0]") {
			open(BOARDDATA, "$boardsdir/$curboard.txt");
			lock(BOARDDATA);
			@messages = <BOARDDATA>;
			unlock(BOARDDATA);
			close(BOARDDATA);

			foreach $curmessage (@messages) {
				($id, $dummy) = split(/\|/, $curmessage);
				unlink("$messagedir/$id\.txt");
				unlink("$messagedir/$id\.mail");
				print "Removing message $id...<br>";
			}
		}
		unlink("$boardsdir/$curboard.txt");
		unlink("$boardsdir/$curboard.mail");
		unlink("$boardsdir/$curboard.dat");
		print "Removing board datafiles...<br>";
	}
	print "Removing category datafiles...<br>";
	unlink("$boardsdir/$curcat.cat");
	print "Done!";
	print_bottom();
	exit;
}

###############
sub createcat {
###############
	if ($username ne "admin") { error("$err{'011'}"); }

	$catid = "$input{'catid'}";

	open(FILE, "$boardsdir/cats.txt") || error("$err{'001'} $boardsdir/cats.txt");
	lock(FILE);
	chomp(@categories = <FILE>);
	unlock(FILE);
	close(FILE);

	open(FILE, ">$boardsdir/cats.txt") || error("$err{'016'} $boardsdir/cats.txt");
	lock(FILE);
	foreach $curcat (@categories) {
		print FILE "$curcat\n";
	}
	print FILE "$catid";
	unlock(FILE);
	close(FILE);

	open(FILE, ">$boardsdir/$catid.cat");
	print FILE "$input{'catname'}\n";
	print FILE "$input{'memgroup'}\n";
	close(FILE);
	print "Location: $pageurl/$admin\&op=managecats\n\n";
	exit;
}

##################
sub manageboards {
##################
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, "$boardsdir/cats.txt") || error("$err{'001'} $boardsdir/cats.txt");
	lock(FILE);
	chomp(@categories = <FILE>);
	unlock(FILE);
	close(FILE);

	print_top();
	$navbar = ">>> $nav{'043'} >>> Manage Boards";

	print qq~<table border="0" cellspacing="1">
<tr>
<td><b>Forum name</b></td>
<td><b>Moderator</b></td>
<td><b>Action</b></td>
</tr>
~;
	foreach $curcat (@categories) {
		open(CAT, "$boardsdir/$curcat.cat");
		lock(CAT);
		chomp(@catinfo = <CAT>);
		unlock(CAT);
		close(CAT);

		$curcatname = "$catinfo[0]";

		print qq~<tr>
<td colspan="3"><a href="$pageurl/$admin&amp;op=reorderboards&cat=$curcat"><b>$curcatname</b></a></td>
</tr>
~;
		foreach $curboard (@catinfo) {
			if ($curboard ne "$catinfo[0]" && $curboard ne "$catinfo[1]") {
				open(BOARD, "$boardsdir/$curboard.dat");
				lock(BOARD);
				@boardinfo = <BOARD>;
				unlock(BOARD);
				close(BOARD);

				$curboardname = "$boardinfo[0]";
				$descr = "$boardinfo[1]";

				open(BOARDDATA, "$boardsdir/$curboard.txt");
				lock(BOARDDATA);
				@messages = <BOARDDATA>;
				unlock(BOARDDATA);
				close(BOARDDATA);

				$moderator = "$modprop[1]";

				print qq~<tr>
<td valign="top"><form action="$pageurl/$admin&amp;op=modifyboard" method="post">
<input type="hidden" name="id" value="$curboard">
<input type="hidden" name="cat" value="$curcat">
<input type="text" name="boardname" value="$curboardname" size="20"><br>
<textarea name="descr" cols="30" rows="3">$descr</textarea>
</td>
<td valign="top"><input type=text name="moderator" value="$boardinfo[2]" size="10"></td>
<td valign="top">
<input type="submit" name="moda" value="Modify">
<input type="submit" name="moda" value="Remove">
</form>
</td>
</tr>
~;
			}
		}
		print qq~<tr>
<td colspan="3"><hr size="1"></td>
</tr>
<tr>
<td valign="top"><form action="$pageurl/$admin&amp;op=createboard" method="post">
<table>
<tr>
<td>ID:</td>
<td><input type="text" name="id" value="" size="15"></td>
</tr>
<tr>
<td>Full name:</td>
<td><input type="text" name="boardname" size="20"></td>
</tr>
<tr>
<td colspan="2">Description:<br>
<textarea name="descr" cols="30" rows="3"></textarea></td>
</tr>
</table>
</td>
<td valign="top"><input type="text" name="moderator" value="" size="10"><input type="hidden" name="cat" value="$curcat"></td>
<td valign="top"><input type="submit" value="Add">
</form>
</td>
</tr>
~;
	}
	print "</table>";
	print_bottom();
	exit;
}

###################
sub reorderboards {
###################
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, "$boardsdir/$info{'cat'}.cat") || error("$err{'001'} $boardsdir/$info{'cat'}.cat");
	lock(FILE);
	chomp(@allboards = <FILE>);
	unlock(FILE);
	close(FILE);

	$boardlist = "";
	foreach $cboard (@allboards) {
		if ($cboard ne "$allboards[0]" && $cboard ne "$allboards[1]") { $boardlist = "$boardlist\n$cboard"; }
	}

	$navbar = ">>> $nav{'043'} >>> Manage Boards >>> Reorder Boards";

	print_top();
	print qq~<table border="0" width="100%" cellpading="0" cellspacing="0">
<tr>
<td valign="top"><form action="$pageurl/$admin&amp;op=reorderboards2" method="post">
<b>Current boards:</b><br>
<textarea name="boards" cols="30" rows="4">$boardlist</textarea><br>
<input type="hidden" name="firstline" value="$allboards[0]">
<input type="hidden" name="secondline" value="$allboards[1]">
<input type="hidden" name="cat" value="$info{'cat'}">
<input type="submit" value="Reorder">
</form>
</td>
</tr>
</table>
~;
	print_bottom();
	exit;
}

####################
sub reorderboards2 {
####################
	if ($username ne "admin") { error("$err{'011'}"); }

	$input{'boards'} =~ s/\r//g;
	$input{'firstline'} =~ s/\n//g;
	$input{'secondline'} =~ s/\n//g;

	open(FILE, ">$boardsdir/$input{'cat'}.cat") || error("$err{'016'} $boardsdir/$input{'cat'}.cat");
	lock(FILE);
	print FILE "$input{'firstline'}\n";
	print FILE "$input{'secondline'}\n";
	print FILE "$input{'boards'}";
	unlock(FILE);
	close(FILE);

	print "Location: $pageurl/$admin\&op=reorderboards\&cat=$input{'cat'}\n\n";
	exit;
}

#################
sub modifyboard {
#################
	if ($username ne "admin") { error("$err{'011'}"); }

	if ($input{'moda'} eq "Modify") {
		$input{'descr'} =~ s/\n/ /g;
		$input{'descr'} =~ s/\r//g;

		open(FILE, ">$boardsdir/$input{'id'}.dat");
		lock(FILE);
		print FILE "$input{'boardname'}\n";
		print FILE "$input{'descr'}\n";
		print FILE "$input{'moderator'}\n";
		unlock(FILE);
		close(FILE);

		print "Location: $pageurl/$admin\&op=manageboards\n\n";
	}
	else {
		open(FILE, "$boardsdir/$input{'cat'}.cat");
		lock(FILE);
		@categories = <FILE>;
		unlock(FILE);
		close(FILE);

		$newcatlist="";
		foreach $curboard (@categories) {
			$curboard =~ s/\n//g;
			if($curboard ne "$input{'id'}") { $newcatlist="$newcatlist$curboard\n"; }
		}
		open(FILE, ">$boardsdir/$input{'cat'}.cat");
		lock(FILE);
		print FILE "$newcatlist";
		unlock(FILE);
		close(FILE);
	
		$curboard="$input{'id'}";
		open(BOARDDATA, "$boardsdir/$curboard.txt");
		lock(BOARDDATA);
		chomp(@messages = <BOARDDATA>);
		unlock(BOARDDATA);
		close(BOARDDATA);

		$navbar = ">>> $nav{'043'} >>> Delete Board";
		print_top();

		foreach $curmessage (@messages) {
			($id, $dummy) = split(/\|/, $curmessage);
			unlink("$messagedir/$id\.txt");
			unlink("$messagedir/$id\.mail");
			print "Removing message $id...<br>";
		}
		print "Removing board datafiles...<br>";
		unlink("$boardsdir/$curboard.dat");
		unlink("$boardsdir/$curboard.txt");
		print "Done!";
		print_bottom();
	}
	exit;
}

#################
sub createboard {
#################
	if ($username ne "admin") { error("$err{'011'}"); }

	$id = "$input{'id'}";
	$input{'descr'} =~ s/\n/ /g;
	$input{'descr'} =~ s/\r//g;
	if ($input{'moderator'} eq "") { $input{'moderator'} eq "admin"; }

	open(FILE, "$boardsdir/$input{'cat'}.cat");
	lock(FILE);
	chomp(@categories = <FILE>);
	unlock(FILE);
	close(FILE);

	open(FILE, ">$boardsdir/$input{'cat'}.cat");
	lock(FILE);
	foreach $curboard (@categories) {
		print FILE "$curboard\n";
	}
	print FILE "$id";
	unlock(FILE);
	close(FILE);

	open(FILE, ">$boardsdir/$id.dat");
	print FILE "$input{'boardname'}\n";
	print FILE "$input{'descr'}\n";
	print FILE "$input{'moderator'}\n";
	close(FILE);

	open(FILE, ">$boardsdir/$id.txt");
	print FILE "";
	close(FILE);

	print "Location: $pageurl/$admin\&op=manageboards\n\n";
	exit;
}

###############
sub setcensor {
###############
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, "$boardsdir/censor.txt") || error("$err{'001'} $boardsdir/censor.txt");
	lock(FILE);
	@censored = <FILE>;
	unlock(FILE);
	close(FILE);

	$navbar = ">>> $nav{'043'} >>>Set Censored Words";

	print_top();

	print qq~<table border="0" width="100%" cellpading="0" cellspacing="0">
<tr>
<td><form action="$pageurl/$admin&amp;op=setcensor2" method="post">
One word per line in the form: fuck=f**ck<br>
<textarea cols="30" rows="6" name="censored">
~;
	foreach $cur (@censored) {
		print "$cur";
	}

	print qq~</textarea><br>
<input type="submit" value="Save">
</form>
</td>
</tr>
</table>
~;
	print_bottom();
	exit;
}

################
sub setcensor2 {
################
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, ">$boardsdir/censor.txt") || error("$err{'016'} $boardsdir/censor.txt");
	lock(FILE);
	print FILE "$FORM{'censored'}";
	unlock(FILE);
	close(FILE);
	print "Location: $admin\&op=setcensor\n\n";
	exit;
}

###############
sub polladmin {
###############
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, "$datadir/polls/polls.txt") || error("$err{'001'} $datadir/polls/polls.txt");
	lock(FILE);
	@data = <FILE>;
	unlock(FILE);
	close(FILE);

	$navbar = ">>> Poll Admin";
	print_top();

	if (@data == 0) { }
	else {
		print qq~<table width="100%" bgcolor="$titlebg" border="0" cellspacing="0" cellpadding="0">
<tr>
<td>
<table width="100%" border="0" cellspacing="1" cellpadding="2">
<tr>
<td bgcolor="$windowbg"><b>Title</b></td>
<td bgcolor="$windowbg"><b>Action</b></td>
~;
		foreach $line (@data) {
			@item = split(/\|/, $line);
			print qq~<tr>
<td bgcolor="$windowbg2"><a href="$pageurl/$cgi?action=pollit2&amp;id=$item[$0]">$item[1]</a></td>
<td bgcolor="$windowbg2">[<a href="$pageurl/$admin&amp;op=editpoll&amp;id=$item[$0]">Edit</a>] [<a href="$admin&amp;op=deletepoll&amp;id=$item[$0]">Delete</a>] [<a href="$admin&amp;op=resetpoll&amp;id=$item[$0]">Reset</a>]</td>
</tr>
~;
		}
		print qq~</table>
</td>
</tr>
</table>
<br><br>
~;
	}
	($num, $name) = split(/\|/, $data[0]);
	$num++;

	print qq~<a href="$pageurl/$admin&amp;op=createpoll&amp;newid=$num"><b>Create a new poll</b></a>~;
	print_bottom();
	exit;

}

################
sub createpoll {
################
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, "$datadir/polls/polls.txt") || error("$err{'001'} $datadir/polls/polls.txt");
	lock(FILE);
	@polls = <FILE>;
	unlock(FILE);
	close(FILE);

	open(FILE, ">$datadir/polls/polls.txt") || error("$err{'016'} $datadir/polls/polls.txt");
	lock(FILE);
	print FILE "$info{'newid'}|Welcome to the Pollbooth\n";
	print FILE @polls;
	unlock(FILE);
	close(FILE);


	open(FILE, ">$datadir/polls/$info{'newid'}_q.dat") || error("$err{'016'} $datadir/polls/$info{'newid'}_q.dat");
	lock(FILE);
	print FILE "Option 1\n";
	unlock(FILE);
	close(FILE);

	open(FILE, ">$datadir/polls/$info{'newid'}_a.dat") || error("$err{'016'} $datadir/polls/$info{'newid'}_a.dat");
	lock(FILE);
	print FILE "0\n";
	unlock(FILE);
	close(FILE);

	open(FILE, ">$datadir/polls/$info{'newid'}_ip.dat") || error("$err{'016'} $datadir/polls/$info{'newid'}_ip.dat");
	lock(FILE);
	unlock(FILE);
	close(FILE);

	print "Location: $pageurl/$admin\&op=editpoll\&id=$info{'newid'}\n\n";
}

##############
sub editpoll {
##############
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, "$datadir/polls/polls.txt") || error("$err{'001'} $datadir/polls/polls.txt");
	lock(FILE);
	chomp(@polls = <FILE>);
	unlock(FILE);
	close(FILE);

	for ($x = 0; $x < @polls; $x++) {
		($id, $name) = split(/\|/, $polls[$x]);
		if ($info{'id'} == $id) { $question = $name; }
	}

	open(FILE, "$datadir/polls/$info{'id'}_q.dat") || error("$err{'001'} $datadir/polls/$info{'id'}_q.dat!");
	lock(FILE);
	@data = <FILE>;
	unlock(FILE);
	close(FILE);

	$navbar = ">>> Poll Admin >>> Edit Poll";
	print_top();
	print qq~<table>
<form action="$pageurl/$admin&amp;op=editpoll2" method="post">
<tr>
<td>Question:</td>
<td><input type="text" name="question" size="40" value="$question"></td>
<td><input type="hidden" name="id" value="$info{'id'}">
<input type="submit" name="moda" value="$btn{'015'}"></td>
</tr>
</form>
~;
	for ($i = 0; $i < @data; $i++) {
		print qq~<form action="$pageurl/$admin&amp;op=editpoll2a" method="post">
<tr>
<td>Answer $i:</td>
<td><input type="text" name="answer" size="40" value="$data[$i]"></td>
<td><input type="hidden" name="id" value="$info{'id'}">
<input type="hidden" name="num" value="$i">
<input type="submit" name="moda" value="$btn{'015'}"><input type="submit" name="moda" value="$btn{'016'}"></td>
</tr>
</form>
~;
	}
	print qq~</table>
</form>
<hr size="1">
<form action="$pageurl/$admin&amp;op=editpoll3" method="post">
<table>
<tr>
<td>Add an answer: <input type="text" name="newanswer" size="40">
<input type="hidden" name="id" value="$info{'id'}">
<input type="submit" name="moda" value="Add"></td>
</tr>
</table>
~;
	print_bottom();
	exit;
}

###############
sub editpoll2 {
###############
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, "$datadir/polls/polls.txt") || error("$err{'001'} $datadir/polls/polls.txt");
	lock(FILE);
	@polls = <FILE>;
	unlock(FILE);
	close(FILE);

	open(FILE, ">$datadir/polls/polls.txt") || error("$err{'016'} $datadir/polls/polls.txt!");
	lock(FILE);
	for ($i = 0; $i < @polls; $i++) {
		($id, $name) = split(/\|/, $polls[$i]);
		if ($input{'id'} eq $id) { print FILE "$id|$input{'question'}\n"; }
		else { print FILE "$polls[$i]"; }
	}
	unlock(FILE);
	close(FILE);

	print "Location: $pageurl/$admin\&op=editpoll\&id=$input{'id'}\n\n";
}

################
sub editpoll2a {
################
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, "$datadir/polls/$input{'id'}_q.dat") || error("$err{'001'} $datadir/polls/$input{'id'}_q.dat!");
	lock(FILE);
	@questions = <FILE>;
	unlock(FILE);
	close(FILE);

	open(FILE, "$datadir/polls/$input{'id'}_a.dat") || error("$err{'001'} $datadir/polls/$input{'id'}_a.dat!");
	lock(FILE);
	@answers = <FILE>;
	unlock(FILE);
	close(FILE);

	if ($input{'moda'} eq $btn{'016'}) {
		open(FILE, ">$datadir/polls/$input{'id'}_q.dat") || error("$err{'001'} $datadir/polls/$input{'id'}_q.dat!");
		lock(FILE);
		for ($i = 0; $i < @questions; $i++) {
			if ($input{'num'} eq $i) { }
			else { print FILE "$questions[$i]"; }
		}
		unlock(FILE);
		close(FILE);

		open(FILE, ">$datadir/polls/$input{'id'}_a.dat") || error("$err{'001'} $datadir/polls/$input{'id'}_a.dat!");
		lock(FILE);
		for ($i = 0; $i < @answers; $i++) {
			if ($input{'num'} eq $i) { }
			else { print FILE "$answers[$i]"; }
		}
		unlock(FILE);
		close(FILE);
	}
	else {
		open(FILE, ">$datadir/polls/$input{'id'}_q.dat") || error("$err{'001'} $datadir/polls/$input{'id'}_q.dat!");
		lock(FILE);
		for ($i = 0; $i < @questions; $i++) {
			if ($input{'num'} eq $i) { print FILE "$input{'answer'}\n"; }
			else { print FILE "$questions[$i]"; }
		}
		unlock(FILE);
		close(FILE);
	}

	print "Location: $pageurl/$admin\&op=editpoll\&id=$input{'id'}\n\n";
}

###############
sub editpoll3 {
###############
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, "$datadir/polls/$input{'id'}_q.dat") || error("$err{'001'} $datadir/polls/$input{'id'}_q.dat!");
	lock(FILE);
	@questions = <FILE>;
	unlock(FILE);
	close(FILE);

	open (FILE, ">$datadir/polls/$input{'id'}_q.dat") || error("$err{'016'} $datadir/polls/$input{'id'}_q.dat!");
	lock(FILE);
	print FILE @questions;
	print FILE "$input{'newanswer'}\n";
	unlock(FILE);
	close(FILE);

	open(FILE, "$datadir/polls/$input{'id'}_a.dat") || error("$err{'001'} $datadir/polls/$input{'id'}_a.dat!");
	lock(FILE);
	@answers = <FILE>;
	unlock(FILE);
	close(FILE);

	open (FILE, ">$datadir/polls/$input{'id'}_a.dat") || error("$err{'016'} $datadir/polls/$input{'id'}_a.dat!");
	lock(FILE);
	print FILE @answers;
	print FILE "0\n";
	unlock(FILE);
	close(FILE);


	print "Location: $pageurl/$admin\&op=editpoll\&id=$input{'id'}\n\n";
}

###############
sub resetpoll {
###############
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, "$datadir/polls/$info{'id'}_a.dat") || error("$err{'001'} $datadir/polls/$info{'id'}_a.dat!");
	lock(FILE);
	chomp(@answers = <FILE>);
	unlock(FILE);
	close(FILE);

	open (FILE, ">$datadir/polls/$info{'id'}_a.dat") || error("$err{'016'} $datadir/polls/$info{'id'}_a.dat!");
	lock(FILE);
	foreach $line (@answers) { print FILE "0\n"; }
	unlock(FILE);
	close(FILE);

	print "Location: $pageurl/$admin\&op=polladmin\n\n";
}

################
sub deletepoll {
################
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, "$datadir/polls/polls.txt") || error("$err{'001'} $datadir/polls/polls.txt");
	lock(FILE);
	chomp(@polls = <FILE>);
	unlock(FILE);
	close(FILE);

	open(FILE, ">$datadir/polls/polls.txt") || error("$err{'001'} $datadir/polls/polls.txt");
	lock(FILE);
	for ($x = 0; $x < @polls; $x++) {
		($id, $name) = split(/\|/, $polls[$x]);
		if ($info{'id'} == $id) { }
		else { print FILE "$polls[$x]\n"; }
	}
	unlock(FILE);
	close(FILE);

	unlink("$datadir/polls/$info{'id'}_q.dat");
	unlink("$datadir/polls/$info{'id'}_a.dat");
	unlink("$datadir/polls/$info{'id'}_ip.dat");

	print "Location: $pageurl/$admin\&op=polladmin\n\n";
}

################
sub verifynews {
################
	if ($username ne "admin") { error("$err{'011'}"); }

	open(TMPDATA, "<$topicsdir/newarticles.dat");
	lock(TMPDATA);
	chomp(@tmpdatas = <TMPDATA>);
	unlock(TMPDATA);
	close(TMPDATA);

	open(FILE, "$topicsdir/cats.dat");
	lock(FILE);
	chomp(@cats = <FILE>);
	unlock(FILE);
	close(FILE);


	for ($a = 0; $a < @tmpdatas; $a++) {
		($id[$a], $cat[$a], $subject[$a], $nick[$a], $postername[$a], $email[$a], $postdate[$a], $message[$a]) = split(/\|/, $tmpdatas[$a]);
	}


	$navbar = ">>> $nav{'024'} >>> Verify News";
	print_top();

	if (@tmpdatas == 0) { print "$msg{'036'}"; }
	else {
		print qq~<table border="0" cellpadding="5" cellspacing="0" width="100%">
<tr>
<td align="center"><b>$msg{'035'}</b></td>
</tr>
</table>
~;
		if ($info{'start'} eq "") { $start = 0; }
		else { $start = "$info{'start'}"; }

		$numshown = 0;
		for ($b = 0; $b < @tmpdatas; $b++) {
			$numshown++;
			$catsdropdown[$b] = "";
			foreach $catslist (@cats) {
				chomp($catslist);
				($name, $link) = split(/\|/, $catslist);
				if ($cat[$b] eq $link) { $sel[$b] = " selected"; }
				else { $sel[$b] = ""; }
				$catsdropdown[$b] = qq~$catsdropdown[$b]\n<option value="$link" $sel[$b]>$name~;
			}

			$message[$b] = htmltotext($message[$b]);

			print qq~<form action="$pageurl/$admin&amp;op=verifynews2" method="post">
<hr noshade="noshade" size="1">
<table>
<tr>
<td colspan="2"><b>Article from $postdate[$b]:</b><input type="hidden" name="postdate" value="$postdate[$b]"></td>
</tr>
<tr>
<td>$msg{'013'}</td>
<td>$nick[$b]<input type="hidden" name="posternick" value="$nick[$b]"></td>
</tr>
<tr>
<td>$msg{'007'}</td>
<td>$email[$b]<input type="hidden" name="posteremail" value="$email[$b]"></td>
</tr>
<tr>
<td>$msg{'034'}</td>
<td>
<select name="cat">$catsdropdown[$b]
</select>
</td>
</tr>
<td>$msg{'037'}</td>
<td><input type="text" name="subject" size="40" maxlength="50" value="$subject[$b]"></td>
</tr>
<tr>
<td valign="top">$msg{'038'}</td>
<td>
<textarea name="message" rows="10" cols="40">$message[$b]</textarea><br>
</td>
</tr>
<td colspan="2" align="center">
<input type="hidden" value="$id[$b]" name="id">
<input type="hidden" name="postername" value="$postername[$b]">
<input type="submit" name="moda" value="$btn{'010'}"><input type="submit" name="moda" value="$btn{'011'}">
</td>
</tr>
</table>
</form>
~;
			if ($numshown >= $maxtopics) { $b = @tmpdatas; }
		}
		if ($numshown >= $maxtopics) {
			print qq~<hr noshade="noshade" size="1">
$msg{'039'} 
~;
			$numcontribs = @tmpdatas;
			$c = 0;
			while (($c*$maxtopics) < $numcontribs) {
				$viewc = $c+1;
				$strt = ($c*$maxtopics);
				if ($start == $strt) { print "$viewc "; }
				elsif ($strt == 0) { print qq~<a href="$pageurl/$admin&amp;op=verifynews">$viewc</a> ~; }
				else { print qq~<a href="$pageurl/$admin&amp;op=verifynews&amp;start=$strt">$viewc</a> ~; }
				$c++;
			}
		}
	}
	print_bottom();
	exit;
}

#################
sub verifynews2 {
#################
	if ($username ne "admin") { error("$err{'011'}"); }
	error("$err{'014'}") unless ($input{'subject'});
	error("$err{'015'}") unless ($input{'message'});

	$subj = htmlescape($input{'subject'});
	$mesg = htmlescape($input{'message'});

	if ($input{'moda'} eq "$btn{'010'}") {
		opendir (DIR, "$topicsdir/articles");
		@files = readdir(DIR);
		closedir (DIR);
		@files = grep(/txt/, @files);
		@files = reverse(sort { $a <=> $b } @files);
		$postnum = @files[0];
		$postnum =~ s/.txt//;
		$postnum++;

		open(DATA, "$topicsdir/newarticles.dat") || error("$err{'010'} $topicsdir/newarticles.dat");
		lock(DATA);
		@data = <DATA>;
		unlock(DATA);
		close(DATA);

		$a = 0;
		while ($data[$a] ne '') { $a++; }

		$count = $a;
		$id = $count + 1;

		$i = 0;

		while ($i < $count) {
			($id, $cat, $subject, $posternick, $postername, $posteremail, $postdate, $message) = split(/\|/, $data[$i]);
			if ($id eq $input{'id'}) {
				open(DATA2, "$topicsdir/$input{'cat'}.cat");
				lock(DATA2);
				chomp(@data2 = <DATA2>);
				unlock(DATA2);
				close(DATA2);

				open(DATA2,">$topicsdir/$input{'cat'}.cat");
				lock(DATA2);
				print DATA2 "$postnum|$subj|$input{'posternick'}|$input{'postername'}|$input{'posteremail'}|$date|0\n";
				for ($x = 0; $x < @data2; $x++) {
					($oldnum, $subject, $posternick, $postername, $posteremail, $postdate, $comments) = split(/\|/, $data2[$x]);
					print DATA2 "$oldnum|$subject|$posternick|$postername|$posteremail|$postdate|$comments\n";
					print FILE "$data2[$x]\n";
				}
				unlock(DATA2);
				close(DATA2);

				open(FILE, ">$topicsdir/articles/$postnum.txt");
				lock(FILE);
				print FILE "$subj|$input{'posternick'}|$input{'postername'}|$input{'posteremail'}|$date|$mesg\n";
				unlock(FILE);
				close(FILE);
			}
			else { }
			$i++;
		}
		open(DATA, ">$topicsdir/newarticles.dat") || error("$err{'016'} $topicsdir/newarticles.dat");
		lock(DATA);
		for ($y = 0; $y < @data; $y++) {
			($id, $cat, $subject, $posternick, $postername, $posteremail, $postdate, $message) = split(/\|/,$data[$y]);
			$message =~ s/[\n\r]//g;
			if ($id ne $input{'id'}) {
				print DATA "$data[$y]";
			}
		}
		unlock(DATA);
		close(DATA);

		open(MEMBERFILE, "$memberdir/$input{'postername'}.dat") || error("$err{'010'} $memberdir/$input{'postername'}.dat");
		lock(MEMBERFILE);
		chomp(@memsett = <MEMBERFILE>);
		unlock(MEMBERFILE);
		close(MEMBERFILE);

		$memsett[11]++;

		open(MEMBERFILE, ">$memberdir/$input{'postername'}.dat") || error("$err{'016'} $memberdir/$input{'postername'}.dat");
		lock(MEMBERFILE);
		for ($i = 0; $i < @memsett; $i++) {
			print MEMBERFILE "$memsett[$i]\n";
		}
		unlock(MEMBERFILE);
		close(MEMBERFILE);
	}
	else {
		open(DATA, "<$topicsdir/newarticles.dat") || error("$err{'010'} $topicsdir/newarticles.dat");
		lock(DATA);
		@data = <DATA>;
		unlock(DATA);
		close(DATA);

		$a = 0;
		while ($data[$a] ne '') { $a++; }

		$count = $a;
		$i = 0;
		$id = $count +1;

		$z = $count;
		$z--;

		open (DATA,">$topicsdir/newarticles.dat") || error("$err{'016'} $topicsdir/newarticles.dat");
		lock(DATA);
		while ($i < $count) {
			($id, $cat, $subject, $posternick, $postername, $posteremail, $postdate, $message) = split(/\|/, $data[$i]);
			if ($id eq $input{'id'}) { }
			else {
				$message =~ s/[\n\r]//g;
				$id = $z;
				print DATA "$id|$cat|$subject|$posternick|$postername|$posteremail|$postdate|$message\n";
				$z--;
			}
			$i++;
		}
		unlock(DATA);
		close(DATA);
	}
	print "Location: $pageurl/$admin&op=verifynews\n\n";
}

################
sub modifynews {
################
	if ($username ne "admin") { error("$err{'011'}"); }

	undef @catnames;
	undef @catlinks;

	open(FILE, "$topicsdir/cats.dat") || error("$err{'001'} $topicsdir/cats.dat");
	lock(FILE);
	chomp(@cats = <FILE>);
	unlock(FILE);
	close(FILE);

	$navbar = ">>> $nav{'024'} >>> Edit/Delete News";
	print_top();
	print qq~<table width="100%" bgcolor="$titlebg" border="0" cellspacing="0" cellpadding="0">
<tr>
<td>
<table width="100%" border="0" cellspacing="1" cellpadding="2">
<tr>
<td bgcolor="$windowbg"><b>ID</b></td>
<td bgcolor="$windowbg"><b>Subject</b></td>
<td bgcolor="$windowbg"><b>Category</b></td>
<td bgcolor="$windowbg"><b>Date</b></td>
<td bgcolor="$windowbg"><b>Poster</b></td>
~;
	foreach (@cats) {
		@item = split(/\|/, $_);
		push(@catnames, $item[0]);
		push(@catlinks, $item[1]);
	}

	foreach $curcat (@catlinks) {
		if (-e("$topicsdir/$curcat.cat")) {
			foreach (@cats) {
				@item = split(/\|/, $_);
				if ($curcat eq "$item[1]") { $curcatname = "$item[0]"; }
			}

			open(FILE, "$topicsdir/$curcat.cat");
			lock(FILE);
			chomp(@articles = <FILE>);
			unlock(FILE);
			close(FILE);

			for ($a = 0; $a < @articles; $a++) {
				($id, $subject, $nick, $poster, $email, $postdate, $comments) = split(/\|/, $articles[$a]);
				if ($second eq "$windowbg3") { $second="$windowbg2"; }
				else { $second="$windowbg3"; }

				print qq~<tr>
<td bgcolor="$second">$id</td>
<td bgcolor="$second"><a href="$pageurl/$admin&amp;op=modifynews2&amp;cat=$curcat&amp;id=$id">$subject</a></td>
<td bgcolor="$second">$curcatname</td>
<td bgcolor="$second">$postdate</td>
<td bgcolor="$second"><a href="mailto:$email">$nick</a></td>
</tr>
~;
			}
		}
	}
			print qq~</table>
</td>
</tr>
</table>
~;
	print_bottom();
	exit;
}

#################
sub modifynews2 {
#################
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, "$topicsdir/articles/$info{'id'}.txt") || error("$err{'001'} $topicsdir/articles/$info{'id'}.txt");
	lock(FILE);
	chomp(@articles = <FILE>);
	unlock(FILE);
	close(FILE);

	$navbar = ">>> $nav{'024'} >>> Edit/Delete News";
	print_top();
	print qq~<table width="100%">
~;

	for ($a = 0; $a < @articles; $a++) {
		($msub, $mname, $musername, $memail, $mdate, $mmessage) = split(/\|/, $articles[$a]);

		$mmessage = htmltotext($mmessage);

		print qq~<form action="$pageurl/$admin&amp;op=modifynews3" method="post">
<input type="hidden" name="cat" value="$info{'cat'}">
<input type="hidden" name="id" value="$info{'id'}">
<input type="hidden" name="viewnum" value="$a">
<tr>
<td valign="top"><a href="mailto:$memail">$mname</a><br>
$mdate</td>
<td><input type="text" name="subject" value="$msub" size="30"><br>
<textarea name="message" rows="3" cols="30">$mmessage</textarea></td>
<td><input type="submit" name="moda" value="$btn{'015'}"><br>
<input type="submit" name="moda" value="$btn{'016'}"></td>
</tr>
<tr>
<td colspan="3"><hr size="1"></td>
</tr>
</form>
~;
	}
	open(FILE, "$topicsdir/cats.dat");
	lock(FILE);
	chomp(@cats = <FILE>);
	unlock(FILE);
	close(FILE);

	foreach $catslist (@cats) {
		chomp($catslist);
		($name, $link) = split(/\|/, $catslist);
		if ($info{'cat'} eq $link) { $sel = "selected"; }
		else { $sel = ""; }
		$catsdropdown = qq~$catsdropdown\n<option value="$link" $sel>$name~;
	}
	print qq~<form action="$pageurl/$admin&amp;op=movetopic" method="post">
<tr>
<td colspan="3">Move to: <select name="tocat">$catsdropdown
</select>
<input type="hidden" name="topic" value="$info{'id'}">
<input type="hidden" name="oldcat" value="$info{'cat'}"><input type="submit" value="Move"></td>
</tr>
</form>
</table>
~;
	print_bottom();
	exit;
}

#################
sub modifynews3 {
#################
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, "$topicsdir/articles/$input{'id'}.txt") || error("$err{'001'} $topicsdir/articles/$input{'id'}.txt");
	lock(FILE);
	@data = <FILE>;
	unlock(FILE);
	close(FILE);

	for ($a = 0; $a < @data; $a++) { 
		($msub[$a], $mname[$a], $musername[$a], $museremail[$a], $mdate[$a], $mmessage[$a]) = split(/\|/, $data[$a]);
	}

	$count = $a;
	if ($input{'viewnum'} == 0 && $count > 1 && $input{'moda'} eq $btn{'016'}) { error("$err{'025'}"); }

	open(FILE, ">$topicsdir/articles/$input{'id'}.txt") || error("$err{'016'} $topicsdir/articles/$input{'id'}.txt");
	lock(FILE);
	for ($b = 0; $b < @data; $b++) {
		if ($input{'viewnum'} eq $b) {
			if ($input{'moda'} eq $btn{'015'}) {
				chomp($input{'subject'});
				chomp($input{'message'});

				$subj = htmlescape($input{'subject'});
				$mesg = htmlescape($input{'message'});

				if ($input{'viewnum'} == 0) {
					open(FILE2, "$topicsdir/$input{'cat'}.cat") || error("$err{'001'} $topicsdir/$input{'cat'}.cat");
					lock(FILE2);
					@data2 = <FILE2>;
					unlock(FILE2);
					close(FILE2);

					open(FILE2, ">$topicsdir/$input{'cat'}.cat") || error("$err{'016'} $topicsdir/$input{'cat'}.cat");
					lock(FILE2);
					for ($a = 0; $a < @data2; $a++) {
						($oldnum, $subject, $posternick, $postername, $posteremail, $postdate, $comments) = split(/\|/, $data2[$a]);
						$comments =~ s/[\n\r]//g;
						if ($oldnum eq $input{'id'}) { 
							print FILE2 "$oldnum|$subj|$posternick|$postername|$posteremail|$postdate|$comments\n"; 
						}
						else { print FILE2 "$data2[$a]"; }
					}
					unlock(FILE2);
					close(FILE2);
				}
				print FILE "$subj|$mname[$b]|$musername[$b]|$museremail[$b]|$mdate[$b]|$mesg\n";
			}
			else {
				open (FILE2, "$topicsdir/$input{'cat'}.cat") || error("$err{'001'} $topicsdir/$input{'cat'}.cat");
				lock(FILE2);
				@data2 = <FILE2>;
				unlock(FILE2);
				close (FILE2);

				open (FILE2, ">$topicsdir/$input{'cat'}.cat") || error("$err{'016'} $topicsdir/$input{'cat'}.cat");
				lock(FILE2);
				for ($a = 0; $a < @data2; $a++) {
					($oldnum, $subject, $posternick, $postername, $posteremail, $postdate, $comments) = split(/\|/, $data2[$a]);
					$comments =~ s/[\n\r]//g;
					$comments--;

					if ($oldnum == $input{'id'}) {
						print FILE2 "$oldnum|$subject|$posternick|$postername|$posteremail|$postdate|$comments\n";
					}
					else { print FILE2 "$data2[$a]"; }
				}
				unlock(FILE2);
				close(FILE2);

				open(MEMBERFILE, "$memberdir/$musername[$b].dat") || error("$err{'010'}");
				lock(MEMBERFILE);
				chomp(@memsett = <MEMBERFILE>);
				unlock(MEMBERFILE);
				close(MEMBERFILE);

				if ($input{'viewnum'} == 0) {
					open(FILE2, "$topicsdir/$input{'cat'}.cat") || error("$err{'001'} $topicsdir/$input{'cat'}.cat");
					lock(FILE2);
					@data2 = <FILE2>;
					unlock(FILE2);
					close(FILE2);

					open(FILE2, ">$topicsdir/$input{'cat'}.cat") || error("$err{'016'} $topicsdir/$input{'cat'}.cat");
					lock(FILE2);
					for ($a = 0; $a < @data2; $a++) {
						($oldnum, $subject, $posternick, $postername, $posteremail, $postdate, $comments) = split(/\|/, $data2[$a]);
						$comments =~ s/[\n\r]//g;
						if ($oldnum eq $input{'id'}) {	}
						else { print FILE2 "$data2[$a]"; }
					}
					unlock(FILE2);
					close(FILE2);

					$memsett[11]--;
					open(MEMBERFILE, ">$memberdir/$musername[$b].dat") || error("$err{'016'} $memberdir/$musername[$b].dat");
					lock(MEMBERFILE);
					for ($i = 0; $i < @memsett; $i++) {
						print MEMBERFILE "$memsett[$i]\n";
					}
					unlock(MEMBERFILE);
					close(MEMBERFILE);
				}
				else {
					$memsett[12]--;
					open(MEMBERFILE, ">$memberdir/$musername[$b].dat") || error("$err{'016'} $memberdir/$musername[$b].dat");
					lock(MEMBERFILE);
					for ($i = 0; $i < @memsett; $i++) {
						print MEMBERFILE "$memsett[$i]\n";
					}
					unlock(MEMBERFILE);
					close(MEMBERFILE);
				}
			}
		}
		else { print FILE "$data[$b]"; }
	}
	unlock(FILE);
	close(FILE);

	print "Location: $pageurl/$admin&op=modifynews\n\n";
	exit;
}

###############
sub movetopic {
###############
	if ($username ne "admin") { error("$err{'011'}"); }

	open (FILE, "$topicsdir/$input{'oldcat'}.cat") || error("$err{'001'} $topicsdir/$input{'cat'}.cat");
	lock(FILE);
	@topics = <FILE>;
	unlock(FILE);
	close (FILE);

	open (FILE, ">$topicsdir/$input{'oldcat'}.cat") || error("$err{'016'} $topicsdir/$input{'cat'}.cat");
	lock(FILE);
	for ($a = 0; $a < @topics; $a++) {
		($num, $subject, $posternick, $postername, $posteremail, $postdate, $comments) = split(/\|/,$topics[$a]);
		$comments  =~ s~[\n\r]~~g;
		if ($num ne $input{'topic'}) { print FILE "$topics[$a]"; }
		else { $linetowrite = "$topics[$a]"; }
	}
	unlock(FILE);
	close(FILE);

	open (FILE, "$topicsdir/$input{'tocat'}.cat");
	lock(FILE);
	@topics = <FILE>;
	unlock(FILE);
	close (FILE);

	open (FILE, ">$topicsdir/$input{'tocat'}.cat");
	lock(FILE);
	print FILE "$linetowrite";
	foreach $line (@topics) {
		print FILE "$line";
	}
	unlock(FILE);
	close(FILE);
	
	print "Location: $pageurl/$admin&op=modifynews\n\n";
	exit;
}

################
sub topicadmin {
################
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, "$topicsdir/cats.dat");
	lock(FILE);
	chomp(@cats = <FILE>);
	unlock(FILE);
	close(FILE);

	$navbar = ">>> $nav{'024'} >>> Topic Admin";
	print_top();
	print qq~<table>
~;

	foreach $line (@cats) {
		@item = split(/\|/, $line);
		print qq~<form action="$admin&amp;op=topicadmin2" method="post">
<tr>
<td><img src="$imagesurl/topics/$item[1].gif" alt="$imagesurl/topics/$item[1].gif"></td>
<td valign="top">
<table>
<tr>
<td>Description:</td>
<td><input type="text" name="desc" value="$item[0]"></td>
</tr>
<tr>
<td>Category:</td>
<td><input type="text" name="cat" value="$item[1]"></td>
</tr>
</table>
</td>
<td valign="top"><input type="hidden" name="oldcat" value="$item[1]"><input type="submit" name="moda" value="$btn{'015'}"><br>
<input type="submit" name="moda" value="$btn{'016'}"></td>
</tr>
</form>
~;
	}
	print qq~<form action="$pageurl/$admin&amp;op=topicadmin3" method="post">
<tr>
<td colspan="2"><hr size="1">
<b>Add Category</b></td>
</tr>
<tr>
<td>Description:</td>
<td><input type="text" name="desc"></td>
</tr>
<tr>
<td>Category:</td>
<td><input type="text" name="cat"></td>
</tr>
<tr>
<td colspan="2"><input type="submit" value="Create"></td>
</tr>
</form>
</table>
~;
	print_bottom();
	exit;
}

#################
sub topicadmin2 {
#################
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, "$topicsdir/cats.dat") || error("$err{'001'} $topicsdir/cats.dat");
	lock(FILE);
	@cats = <FILE>;
	unlock(FILE);
	close(FILE);

	if ($input{'moda'} eq $btn{'015'}) {
		chomp($input{'oldcat'});

		open(FILE, ">$topicsdir/cats.dat") || error("$err{'016'} $topicsdir/cats.dat");
		lock(FILE);
		foreach $line (@cats) {
			chomp($line);
			($name, $link) = split(/\|/, $line);
			if ($input{'oldcat'} eq $link) { print FILE "$input{'desc'}|$input{'cat'}\n"; }
			else { print FILE "$line\n"; }
		}
		unlock(FILE);
		close(FILE);

		open(FILE, "$topicsdir/$input{'oldcat'}.cat");
		lock(FILE);
		chomp(@topics = <FILE>);
		unlock(FILE);
		close(FILE);

		open(FILE, ">$topicsdir/$input{'cat'}.cat");
		lock(FILE);
		foreach $line (@topics) {
			print FILE "$line\n";
		}
		unlock(FILE);
		close(FILE);

		unlink("$topicsdir/$input{'oldcat'}.cat");
	}
	if ($input{'moda'} eq $btn{'016'}) {
		open(FILE, "$topicsdir/$input{'cat'}.cat");
		lock(FILE);
		@data = <FILE>;
		unlock(FILE);
		close(FILE);

		if (@data != 0) { error("$err{'025'}"); }
		chomp($input{'cat'});

		open(FILE, ">$topicsdir/cats.dat") || error("$err{'016'} $topicsdir/cats.dat");
		lock(FILE);
		foreach $line (@cats) {
			chomp($line);
			($name, $link) = split(/\|/, $line);
			if ($input{'cat'} eq $link) { }
			else { print FILE "$line\n"; }
		}
		unlock(FILE);
		close(FILE);

		unlink("$topicsdir/$input{'cat'}.cat");
	}

	print "Location: $pageurl/$admin&op=topicadmin\n\n";
	exit;
}

#################
sub topicadmin3 {
#################
	if ($username ne "admin") { error("$err{'011'}"); }

	open(FILE, "$topicsdir/cats.dat") || error("$err{'001'} $topicsdir/cats.dat");
	lock(FILE);
	@cats = <FILE>;
	unlock(FILE);
	close(FILE);

	open(FILE, ">$topicsdir/cats.dat") || error("$err{'016'} $topicsdir/cats.dat");
	lock(FILE);
	print FILE "$input{'desc'}|$input{'cat'}\n";
	print FILE @cats;
	unlock(FILE);
	close(FILE);

	print "Location: $pageurl/$admin&op=topicadmin\n\n";
	exit;
}


1; # return true
